using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "fire_fang")]
public class FireFang : Script, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var battleData = target.BattleData;
        if (battleData == null)
            return;
        var random = battleData.Battle.Random;
        if (random.EffectChance(10, move, target, hit))
        {
            target.SetStatus("burned", move.User);
        }

        // It also has an independent 10% chance of causing the target to flinch, if the user attacks before the target. 
        var choiceQueue = battleData.Battle.ChoiceQueue;
        if (choiceQueue?.FirstOrDefault(x => x.User == target) != null)
        {
            if (random.EffectChance(10, move, target, hit))
            {
                target.Volatile.Add(new FlinchEffect());
            }
        }
    }
}